// autogenerated by syzkaller (https://github.com/google/syzkaller)

#define _GNU_SOURCE

#include <dirent.h>
#include <endian.h>
#include <errno.h>
#include <fcntl.h>
#include <setjmp.h>
#include <signal.h>
#include <stdarg.h>
#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/ioctl.h>
#include <sys/mman.h>
#include <sys/mount.h>
#include <sys/prctl.h>
#include <sys/stat.h>
#include <sys/syscall.h>
#include <sys/types.h>
#include <sys/wait.h>
#include <time.h>
#include <unistd.h>

#include <linux/loop.h>

#ifndef __NR_memfd_create
#define __NR_memfd_create 319
#endif

static unsigned long long procid;

static void sleep_ms(uint64_t ms)
{
  usleep(ms * 1000);
}

static uint64_t current_time_ms(void)
{
  struct timespec ts;
  if (clock_gettime(CLOCK_MONOTONIC, &ts))
    exit(1);
  return (uint64_t)ts.tv_sec * 1000 + (uint64_t)ts.tv_nsec / 1000000;
}

static bool write_file(const char* file, const char* what, ...)
{
  char buf[1024];
  va_list args;
  va_start(args, what);
  vsnprintf(buf, sizeof(buf), what, args);
  va_end(args);
  buf[sizeof(buf) - 1] = 0;
  int len = strlen(buf);
  int fd = open(file, O_WRONLY | O_CLOEXEC);
  if (fd == -1)
    return false;
  if (write(fd, buf, len) != len) {
    int err = errno;
    close(fd);
    errno = err;
    return false;
  }
  close(fd);
  return true;
}

//% This code is derived from puff.{c,h}, found in the zlib development. The
//% original files come with the following copyright notice:

//% Copyright (C) 2002-2013 Mark Adler, all rights reserved
//% version 2.3, 21 Jan 2013
//% This software is provided 'as-is', without any express or implied
//% warranty.  In no event will the author be held liable for any damages
//% arising from the use of this software.
//% Permission is granted to anyone to use this software for any purpose,
//% including commercial applications, and to alter it and redistribute it
//% freely, subject to the following restrictions:
//% 1. The origin of this software must not be misrepresented; you must not
//%    claim that you wrote the original software. If you use this software
//%    in a product, an acknowledgment in the product documentation would be
//%    appreciated but is not required.
//% 2. Altered source versions must be plainly marked as such, and must not be
//%    misrepresented as being the original software.
//% 3. This notice may not be removed or altered from any source distribution.
//% Mark Adler    madler@alumni.caltech.edu

//% BEGIN CODE DERIVED FROM puff.{c,h}

#define MAXBITS 15
#define MAXLCODES 286
#define MAXDCODES 30
#define MAXCODES (MAXLCODES + MAXDCODES)
#define FIXLCODES 288

struct puff_state {
  unsigned char* out;
  unsigned long outlen;
  unsigned long outcnt;
  const unsigned char* in;
  unsigned long inlen;
  unsigned long incnt;
  int bitbuf;
  int bitcnt;
  jmp_buf env;
};
static int puff_bits(struct puff_state* s, int need)
{
  long val = s->bitbuf;
  while (s->bitcnt < need) {
    if (s->incnt == s->inlen)
      longjmp(s->env, 1);
    val |= (long)(s->in[s->incnt++]) << s->bitcnt;
    s->bitcnt += 8;
  }
  s->bitbuf = (int)(val >> need);
  s->bitcnt -= need;
  return (int)(val & ((1L << need) - 1));
}
static int puff_stored(struct puff_state* s)
{
  s->bitbuf = 0;
  s->bitcnt = 0;
  if (s->incnt + 4 > s->inlen)
    return 2;
  unsigned len = s->in[s->incnt++];
  len |= s->in[s->incnt++] << 8;
  if (s->in[s->incnt++] != (~len & 0xff) ||
      s->in[s->incnt++] != ((~len >> 8) & 0xff))
    return -2;
  if (s->incnt + len > s->inlen)
    return 2;
  if (s->outcnt + len > s->outlen)
    return 1;
  for (; len--; s->outcnt++, s->incnt++) {
    if (s->in[s->incnt])
      s->out[s->outcnt] = s->in[s->incnt];
  }
  return 0;
}
struct puff_huffman {
  short* count;
  short* symbol;
};
static int puff_decode(struct puff_state* s, const struct puff_huffman* h)
{
  int first = 0;
  int index = 0;
  int bitbuf = s->bitbuf;
  int left = s->bitcnt;
  int code = first = index = 0;
  int len = 1;
  short* next = h->count + 1;
  while (1) {
    while (left--) {
      code |= bitbuf & 1;
      bitbuf >>= 1;
      int count = *next++;
      if (code - count < first) {
        s->bitbuf = bitbuf;
        s->bitcnt = (s->bitcnt - len) & 7;
        return h->symbol[index + (code - first)];
      }
      index += count;
      first += count;
      first <<= 1;
      code <<= 1;
      len++;
    }
    left = (MAXBITS + 1) - len;
    if (left == 0)
      break;
    if (s->incnt == s->inlen)
      longjmp(s->env, 1);
    bitbuf = s->in[s->incnt++];
    if (left > 8)
      left = 8;
  }
  return -10;
}
static int puff_construct(struct puff_huffman* h, const short* length, int n)
{
  int len;
  for (len = 0; len <= MAXBITS; len++)
    h->count[len] = 0;
  int symbol;
  for (symbol = 0; symbol < n; symbol++)
    (h->count[length[symbol]])++;
  if (h->count[0] == n)
    return 0;
  int left = 1;
  for (len = 1; len <= MAXBITS; len++) {
    left <<= 1;
    left -= h->count[len];
    if (left < 0)
      return left;
  }
  short offs[MAXBITS + 1];
  offs[1] = 0;
  for (len = 1; len < MAXBITS; len++)
    offs[len + 1] = offs[len] + h->count[len];
  for (symbol = 0; symbol < n; symbol++)
    if (length[symbol] != 0)
      h->symbol[offs[length[symbol]]++] = symbol;
  return left;
}
static int puff_codes(struct puff_state* s, const struct puff_huffman* lencode,
                      const struct puff_huffman* distcode)
{
  static const short lens[29] = {3,  4,  5,  6,   7,   8,   9,   10,  11, 13,
                                 15, 17, 19, 23,  27,  31,  35,  43,  51, 59,
                                 67, 83, 99, 115, 131, 163, 195, 227, 258};
  static const short lext[29] = {0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1, 2, 2, 2,
                                 2, 3, 3, 3, 3, 4, 4, 4, 4, 5, 5, 5, 5, 0};
  static const short dists[30] = {
      1,    2,    3,    4,    5,    7,    9,    13,    17,    25,
      33,   49,   65,   97,   129,  193,  257,  385,   513,   769,
      1025, 1537, 2049, 3073, 4097, 6145, 8193, 12289, 16385, 24577};
  static const short dext[30] = {0, 0, 0,  0,  1,  1,  2,  2,  3,  3,
                                 4, 4, 5,  5,  6,  6,  7,  7,  8,  8,
                                 9, 9, 10, 10, 11, 11, 12, 12, 13, 13};
  int symbol;
  do {
    symbol = puff_decode(s, lencode);
    if (symbol < 0)
      return symbol;
    if (symbol < 256) {
      if (s->outcnt == s->outlen)
        return 1;
      if (symbol)
        s->out[s->outcnt] = symbol;
      s->outcnt++;
    } else if (symbol > 256) {
      symbol -= 257;
      if (symbol >= 29)
        return -10;
      int len = lens[symbol] + puff_bits(s, lext[symbol]);
      symbol = puff_decode(s, distcode);
      if (symbol < 0)
        return symbol;
      unsigned dist = dists[symbol] + puff_bits(s, dext[symbol]);
      if (dist > s->outcnt)
        return -11;
      if (s->outcnt + len > s->outlen)
        return 1;
      while (len--) {
        if (dist <= s->outcnt && s->out[s->outcnt - dist])
          s->out[s->outcnt] = s->out[s->outcnt - dist];
        s->outcnt++;
      }
    }
  } while (symbol != 256);
  return 0;
}
static int puff_fixed(struct puff_state* s)
{
  static int virgin = 1;
  static short lencnt[MAXBITS + 1], lensym[FIXLCODES];
  static short distcnt[MAXBITS + 1], distsym[MAXDCODES];
  static struct puff_huffman lencode, distcode;
  if (virgin) {
    lencode.count = lencnt;
    lencode.symbol = lensym;
    distcode.count = distcnt;
    distcode.symbol = distsym;
    short lengths[FIXLCODES];
    int symbol;
    for (symbol = 0; symbol < 144; symbol++)
      lengths[symbol] = 8;
    for (; symbol < 256; symbol++)
      lengths[symbol] = 9;
    for (; symbol < 280; symbol++)
      lengths[symbol] = 7;
    for (; symbol < FIXLCODES; symbol++)
      lengths[symbol] = 8;
    puff_construct(&lencode, lengths, FIXLCODES);
    for (symbol = 0; symbol < MAXDCODES; symbol++)
      lengths[symbol] = 5;
    puff_construct(&distcode, lengths, MAXDCODES);
    virgin = 0;
  }
  return puff_codes(s, &lencode, &distcode);
}
static int puff_dynamic(struct puff_state* s)
{
  static const short order[19] = {16, 17, 18, 0, 8,  7, 9,  6, 10, 5,
                                  11, 4,  12, 3, 13, 2, 14, 1, 15};
  int nlen = puff_bits(s, 5) + 257;
  int ndist = puff_bits(s, 5) + 1;
  int ncode = puff_bits(s, 4) + 4;
  if (nlen > MAXLCODES || ndist > MAXDCODES)
    return -3;
  short lengths[MAXCODES];
  int index;
  for (index = 0; index < ncode; index++)
    lengths[order[index]] = puff_bits(s, 3);
  for (; index < 19; index++)
    lengths[order[index]] = 0;
  short lencnt[MAXBITS + 1], lensym[MAXLCODES];
  struct puff_huffman lencode = {lencnt, lensym};
  int err = puff_construct(&lencode, lengths, 19);
  if (err != 0)
    return -4;
  index = 0;
  while (index < nlen + ndist) {
    int symbol;
    int len;
    symbol = puff_decode(s, &lencode);
    if (symbol < 0)
      return symbol;
    if (symbol < 16)
      lengths[index++] = symbol;
    else {
      len = 0;
      if (symbol == 16) {
        if (index == 0)
          return -5;
        len = lengths[index - 1];
        symbol = 3 + puff_bits(s, 2);
      } else if (symbol == 17)
        symbol = 3 + puff_bits(s, 3);
      else
        symbol = 11 + puff_bits(s, 7);
      if (index + symbol > nlen + ndist)
        return -6;
      while (symbol--)
        lengths[index++] = len;
    }
  }
  if (lengths[256] == 0)
    return -9;
  err = puff_construct(&lencode, lengths, nlen);
  if (err && (err < 0 || nlen != lencode.count[0] + lencode.count[1]))
    return -7;
  short distcnt[MAXBITS + 1], distsym[MAXDCODES];
  struct puff_huffman distcode = {distcnt, distsym};
  err = puff_construct(&distcode, lengths + nlen, ndist);
  if (err && (err < 0 || ndist != distcode.count[0] + distcode.count[1]))
    return -8;
  return puff_codes(s, &lencode, &distcode);
}
static int puff(unsigned char* dest, unsigned long* destlen,
                const unsigned char* source, unsigned long sourcelen)
{
  struct puff_state s = {
      .out = dest,
      .outlen = *destlen,
      .outcnt = 0,
      .in = source,
      .inlen = sourcelen,
      .incnt = 0,
      .bitbuf = 0,
      .bitcnt = 0,
  };
  int err;
  if (setjmp(s.env) != 0)
    err = 2;
  else {
    int last;
    do {
      last = puff_bits(&s, 1);
      int type = puff_bits(&s, 2);
      err = type == 0 ? puff_stored(&s)
                      : (type == 1 ? puff_fixed(&s)
                                   : (type == 2 ? puff_dynamic(&s) : -1));
      if (err != 0)
        break;
    } while (!last);
  }
  *destlen = s.outcnt;
  return err;
}

//% END CODE DERIVED FROM puff.{c,h}

#define ZLIB_HEADER_WIDTH 2

static int puff_zlib_to_file(const unsigned char* source,
                             unsigned long sourcelen, int dest_fd)
{
  if (sourcelen < ZLIB_HEADER_WIDTH)
    return 0;
  source += ZLIB_HEADER_WIDTH;
  sourcelen -= ZLIB_HEADER_WIDTH;
  const unsigned long max_destlen = 132 << 20;
  void* ret = mmap(0, max_destlen, PROT_WRITE | PROT_READ,
                   MAP_PRIVATE | MAP_ANON, -1, 0);
  if (ret == MAP_FAILED)
    return -1;
  unsigned char* dest = (unsigned char*)ret;
  unsigned long destlen = max_destlen;
  int err = puff(dest, &destlen, source, sourcelen);
  if (err) {
    munmap(dest, max_destlen);
    errno = -err;
    return -1;
  }
  if (write(dest_fd, dest, destlen) != (ssize_t)destlen) {
    munmap(dest, max_destlen);
    return -1;
  }
  return munmap(dest, max_destlen);
}

static int setup_loop_device(unsigned char* data, unsigned long size,
                             const char* loopname, int* loopfd_p)
{
  int err = 0, loopfd = -1;
  int memfd = syscall(__NR_memfd_create, "syzkaller", 0);
  if (memfd == -1) {
    err = errno;
    goto error;
  }
  if (puff_zlib_to_file(data, size, memfd)) {
    err = errno;
    goto error_close_memfd;
  }
  loopfd = open(loopname, O_RDWR);
  if (loopfd == -1) {
    err = errno;
    goto error_close_memfd;
  }
  if (ioctl(loopfd, LOOP_SET_FD, memfd)) {
    if (errno != EBUSY) {
      err = errno;
      goto error_close_loop;
    }
    ioctl(loopfd, LOOP_CLR_FD, 0);
    usleep(1000);
    if (ioctl(loopfd, LOOP_SET_FD, memfd)) {
      err = errno;
      goto error_close_loop;
    }
  }
  close(memfd);
  *loopfd_p = loopfd;
  return 0;

error_close_loop:
  close(loopfd);
error_close_memfd:
  close(memfd);
error:
  errno = err;
  return -1;
}

static void reset_loop_device(const char* loopname)
{
  int loopfd = open(loopname, O_RDWR);
  if (loopfd == -1) {
    return;
  }
  if (ioctl(loopfd, LOOP_CLR_FD, 0)) {
  }
  close(loopfd);
}

static long syz_mount_image(volatile long fsarg, volatile long dir,
                            volatile long flags, volatile long optsarg,
                            volatile long change_dir,
                            volatile unsigned long size, volatile long image)
{
  unsigned char* data = (unsigned char*)image;
  int res = -1, err = 0, need_loop_device = !!size;
  char* mount_opts = (char*)optsarg;
  char* target = (char*)dir;
  char* fs = (char*)fsarg;
  char* source = NULL;
  char loopname[64];
  if (need_loop_device) {
    int loopfd;
    memset(loopname, 0, sizeof(loopname));
    snprintf(loopname, sizeof(loopname), "/dev/loop%llu", procid);
    if (setup_loop_device(data, size, loopname, &loopfd) == -1)
      return -1;
    close(loopfd);
    source = loopname;
  }
  mkdir(target, 0777);
  char opts[256];
  memset(opts, 0, sizeof(opts));
  if (strlen(mount_opts) > (sizeof(opts) - 32)) {
  }
  strncpy(opts, mount_opts, sizeof(opts) - 32);
  if (strcmp(fs, "iso9660") == 0) {
    flags |= MS_RDONLY;
  } else if (strncmp(fs, "ext", 3) == 0) {
    bool has_remount_ro = false;
    char* remount_ro_start = strstr(opts, "errors=remount-ro");
    if (remount_ro_start != NULL) {
      char after = *(remount_ro_start + strlen("errors=remount-ro"));
      char before = remount_ro_start == opts ? '\0' : *(remount_ro_start - 1);
      has_remount_ro = ((before == '\0' || before == ',') &&
                        (after == '\0' || after == ','));
    }
    if (strstr(opts, "errors=panic") || !has_remount_ro)
      strcat(opts, ",errors=continue");
  } else if (strcmp(fs, "xfs") == 0) {
    strcat(opts, ",nouuid");
  }
  res = mount(source, target, fs, flags, opts);
  if (res == -1) {
    err = errno;
    goto error_clear_loop;
  }
  res = open(target, O_RDONLY | O_DIRECTORY);
  if (res == -1) {
    err = errno;
    goto error_clear_loop;
  }
  if (change_dir) {
    res = chdir(target);
    if (res == -1) {
      err = errno;
    }
  }

error_clear_loop:
  if (need_loop_device)
    reset_loop_device(loopname);
  errno = err;
  return res;
}

static void kill_and_wait(int pid, int* status)
{
  kill(-pid, SIGKILL);
  kill(pid, SIGKILL);
  for (int i = 0; i < 100; i++) {
    if (waitpid(-1, status, WNOHANG | __WALL) == pid)
      return;
    usleep(1000);
  }
  DIR* dir = opendir("/sys/fs/fuse/connections");
  if (dir) {
    for (;;) {
      struct dirent* ent = readdir(dir);
      if (!ent)
        break;
      if (strcmp(ent->d_name, ".") == 0 || strcmp(ent->d_name, "..") == 0)
        continue;
      char abort[300];
      snprintf(abort, sizeof(abort), "/sys/fs/fuse/connections/%s/abort",
               ent->d_name);
      int fd = open(abort, O_WRONLY);
      if (fd == -1) {
        continue;
      }
      if (write(fd, abort, 1) < 0) {
      }
      close(fd);
    }
    closedir(dir);
  } else {
  }
  while (waitpid(-1, status, __WALL) != pid) {
  }
}

static void reset_loop()
{
  char buf[64];
  snprintf(buf, sizeof(buf), "/dev/loop%llu", procid);
  int loopfd = open(buf, O_RDWR);
  if (loopfd != -1) {
    ioctl(loopfd, LOOP_CLR_FD, 0);
    close(loopfd);
  }
}

static void setup_test()
{
  prctl(PR_SET_PDEATHSIG, SIGKILL, 0, 0, 0);
  setpgrp();
  write_file("/proc/self/oom_score_adj", "1000");
}

static void execute_one(void);

#define WAIT_FLAGS __WALL

static void loop(void)
{
  int iter = 0;
  for (;; iter++) {
    reset_loop();
    int pid = fork();
    if (pid < 0)
      exit(1);
    if (pid == 0) {
      setup_test();
      execute_one();
      exit(0);
    }
    int status = 0;
    uint64_t start = current_time_ms();
    for (;;) {
      if (waitpid(-1, &status, WNOHANG | WAIT_FLAGS) == pid)
        break;
      sleep_ms(1);
      if (current_time_ms() - start < 5000)
        continue;
      kill_and_wait(pid, &status);
      break;
    }
  }
}

void execute_one(void)
{
  memcpy((void*)0x20000600, "hfsplus\000", 8);
  memcpy((void*)0x20000640, "./file1\000", 8);
  memcpy(
      (void*)0x20000c80,
      "\x78\x9c\xec\xdd\x4f\x6f\x1c\x67\x1d\x07\xf0\xef\x6c\x1c\xc7\x0e\x52\xba"
      "\x6d\x93\xb6\x20\x10\x56\x72\x00\x35\x22\xf1\xee\xb6\xa9\x0f\x48\x04\x84"
      "\x90\x0f\x15\xaa\xc4\xa5\x97\x1e\xac\x64\xd3\x58\xd9\xb8\x95\xbd\x45\x6e"
      "\x85\x20\xe1\xef\x95\x77\xd0\x72\x70\xce\x9c\x38\x20\x0e\x91\xca\x99\xb7"
      "\x60\x89\x43\x0f\x48\x48\x1c\x2d\x2e\x46\x33\x3b\x6b\x2f\xb6\xeb\xd8\xa9"
      "\xe3\xb5\xdb\xcf\x47\x7a\xe6\x79\x66\x9e\x99\x67\x9e\xe7\x97\x99\xc7\x3b"
      "\xb3\x8a\x36\xc0\x57\xd6\xfc\xdb\x39\xfb\x38\x45\xe6\xaf\xbe\xb9\x5a\xae"
      "\xaf\xaf\x75\x7a\xeb\x6b\x9d\xfb\xc3\x72\x92\x73\x49\x1a\xc9\xc4\x20\x4b"
      "\xb1\x94\x14\x9f\x26\x37\x33\x48\xf9\x7a\xb9\xb1\x6e\xae\xf8\xbc\xf3\xbc"
      "\xf3\xf1\x1b\x73\x9f\xb5\x1e\x3d\x1c\xac\x4d\xd4\xa9\xda\xbf\xb1\xdf\x71"
      "\x07\xf3\xa0\x4e\x99\x49\x72\xa6\xce\xb7\x6d\xd6\x9e\xae\xbd\x5b\xbb\xda"
      "\x3b\xac\x62\x6b\x84\x65\xc0\xae\x0c\x03\x07\xe3\xb6\xb9\xcb\x83\xc3\x1c"
      "\xfe\x05\xef\x5b\xe0\x24\x28\x06\x7f\x37\x77\x69\x26\xe7\x93\x4c\xd5\x9f"
      "\x03\x52\xcf\x0e\x8d\xe3\xed\xdd\xd1\x3b\xd4\x2c\x07\x00\x00\x00\xa7\xd4"
      "\x73\x1b\xd9\xc8\x6a\x2e\x8c\xbb\x1f\x00\x00\x00\x00\x00\x00\x00\x00\x00"
      "\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00"
      "\x70\x9a\xd4\xbf\xff\x5f\xd4\xa9\x31\x2c\xcf\xa4\x18\xfe\xfe\xff\x64\xbd"
      "\x2d\x75\xf9\x54\x7b\x3c\xee\x0e\x00\x00\x00\x00\x00\x00\x00\xc0\x11\xf8"
      "\xf6\x46\x36\xb2\x9a\x0b\x49\x36\x7f\x55\x2e\x8a\xea\x3b\xff\xcb\x55\xe5"
      "\xc5\x6a\xf9\xb5\x7c\x90\x95\x74\xb3\x9c\x6b\x59\xcd\x42\xfa\xe9\x67\x39"
      "\xad\x24\xcd\x91\x86\x26\x57\x17\xfa\xfd\xe5\xd6\x01\x8e\x6c\xef\x79\x64"
      "\xfb\x18\x07\x0d\x00\x00\x00\x00\x00\x00\x00\x5f\x3e\xbf\xce\x7c\xf5\xfd"
      "\x3f\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00"
      "\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00"
      "\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x9c\x18\x45\x72\x66\x90"
      "\x55\xe9\xe2\xb0\xdc\x4c\x63\x22\xc9\x54\x92\xc9\x72\xbf\x07\xc9\xdf\x86"
      "\xe5\xd3\xec\xf1\xb8\x3b\x00\x00\x00\x00\xc7\xe0\xb9\x8d\x6c\x64\x35\x17"
      "\x86\xeb\x9b\x45\xf5\xcc\xff\x52\xf5\xdc\x3f\x95\x0f\xb2\x94\x7e\x16\xd3"
      "\x4f\x2f\xdd\xdc\xae\xde\x05\x0c\x9e\xfa\x1b\xeb\x6b\x9d\xde\xfa\x5a\xe7"
      "\x7e\x99\x76\xb7\xfb\xc3\x7f\x1f\xaa\x1b\x55\x8b\x19\xbc\x7b\xd8\xfb\xcc"
      "\xb3\xd5\x1e\x97\xca\xea\xff\x96\x8b\xf9\xfc\x24\x3f\xcb\xd5\xcc\xe4\xad"
      "\x2c\x67\x31\x3f\xcf\x42\xfa\xe9\x66\x26\x3f\xae\x4a\x0b\x29\xd2\xac\xdf"
      "\x5e\x34\x87\xfd\xdc\xbb\xbf\x37\xff\x6f\xed\xad\x27\xf5\xf5\x95\xaa\x27"
      "\xd3\xb9\x93\xc5\xaa\x6f\xd7\x72\x2b\xef\xa5\x97\xdb\x69\x54\x63\xa8\xf6"
      "\xd9\xff\x8c\x0f\xcb\xe8\x14\x3f\xa8\x1d\x30\x46\xb7\xeb\xbc\x1c\xd1\x1f"
      "\xeb\xfc\x64\x68\x56\x11\x39\xbb\x15\x91\xd9\x3a\xf6\x65\x34\x9e\xdf\x3f"
      "\x12\x87\xbc\x4e\x76\x9e\xa9\x95\xc6\xd6\x3b\xa8\x8b\xcf\x20\xe6\xe7\xeb"
      "\xbc\x8c\xf5\xef\x4f\x74\xcc\xdb\x23\x57\xdf\x4b\xfb\x47\x22\xb9\xfc\xcf"
      "\x6f\xfd\xe5\x6e\x6f\xe9\xde\xdd\x3b\x2b\x57\x4f\xce\x90\x9e\xd2\xce\x48"
      "\x74\x46\x22\xf1\xf2\x57\x2a\x12\x93\x75\x34\x06\xb3\x68\x3d\x5b\x56\x9e"
      "\x3c\x5b\x5e\xae\x8e\xbd\x90\xc5\xfc\x34\xef\xe5\x76\xba\x79\x3d\x73\x79"
      "\x3d\xed\xbc\x96\xd7\x32\x9b\xb9\xdc\x18\x89\xeb\xa5\x03\xdc\x6b\x8d\xc3"
      "\xdd\x6b\x57\xbe\x5b\x17\xa6\x93\xfc\xa1\xce\x4f\x86\x32\xae\xcf\x8f\xc4"
      "\x75\x74\xa6\x6b\x56\x75\xa3\x5b\xb6\xa3\xf4\xc2\xd1\xcf\x48\x13\xdf\xa8"
      "\x0b\xe5\x39\x7e\x53\xe7\x27\xc3\xce\x48\xb4\x46\x22\xf1\xe2\xfe\x91\xf8"
      "\xd3\x66\xb9\x5c\xe9\x2d\xdd\x5b\xbe\xbb\xf0\xfe\x5e\x8d\xff\x67\x73\x73"
      "\xe7\xa6\xef\xd4\x79\x79\xdb\xfe\xee\xa9\xe6\xe6\xa9\x43\x1f\x71\x30\xe5"
      "\xf5\xf2\x42\xf9\x8f\xd5\xce\xae\xab\xa3\xac\x7b\xb1\xac\xcb\xce\xba\x56"
      "\x55\x77\x71\xab\xae\xb1\xab\xee\xd2\x56\xdd\x93\xee\xd4\xc9\xfa\x33\xdc"
      "\xee\x96\xda\x55\xdd\xcb\x7b\xd6\x75\xaa\xba\x57\x46\xea\xf6\xfa\x94\x93"
      "\xcc\x3c\xa3\xb8\x01\x70\x44\xce\xbf\x7a\x7e\x72\xfa\x5f\xd3\xff\x98\xfe"
      "\x64\xfa\xb7\xd3\x77\xa7\xdf\x9c\xfa\xd1\xb9\xb9\x73\xdf\x9c\xcc\xd9\xbf"
      "\x4f\xfc\xf5\xcc\x9f\x1b\x8f\x1a\xdf\x2f\x5e\xcd\x27\xf9\xe5\xf6\xf3\x3f"
      "\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00"
      "\x00\x00\x00\x00\x00\xf0\xf4\x56\x3e\xfc\xe8\xde\x42\xaf\xd7\x5d\x56\x50"
      "\x50\x50\xd8\x2a\x8c\x7b\x66\x02\x9e\xb5\xeb\xfd\xfb\xef\x5f\x5f\xf9\xf0"
      "\xa3\xef\x2d\xde\x5f\x78\xb7\xfb\x6e\x77\xa9\xd3\x69\xdd\x68\xcf\xdd\x98"
      "\x6b\xdf\xb8\x7e\x67\xb1\xd7\x9d\x1d\x2c\xc7\xdd\x4d\xe0\x19\xd8\xfe\xa3"
      "\x3f\xee\x9e\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x07\x75\x1c\xff\x9d"
      "\x60\xdc\x63\x04\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00"
      "\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00"
      "\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00"
      "\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00"
      "\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00"
      "\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00"
      "\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00"
      "\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00"
      "\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00"
      "\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00"
      "\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00"
      "\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00"
      "\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00"
      "\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00"
      "\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00"
      "\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00"
      "\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00"
      "\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00"
      "\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00"
      "\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00"
      "\x00\x00\x00\x00\x00\x00\x00\x4e\xb7\xf9\xb7\x73\xf6\x71\x8a\xb4\x66\xaf"
      "\xcd\x96\xeb\xeb\x6b\x9d\x5e\x99\x86\xe5\xed\x3d\x27\x92\x34\x92\x14\xbf"
      "\x48\x8a\x4f\x93\x9b\x19\xa4\x34\x47\x9a\x2b\x3e\xef\x3c\xef\x7c\xfc\xc6"
      "\xdc\x67\xad\x47\x0f\xb7\xdb\x9a\x18\xee\xdf\xd8\xef\xb8\x83\x79\x50\xa7"
      "\xcc\x24\x39\x53\xe7\x47\xd5\xde\xad\x2f\xdc\x5e\xb1\x35\xc2\x32\x60\x57"
      "\x86\x81\x83\x71\xfb\x5f\x00\x00\x00\xff\xff\x86\x8c\x1c\x19",
      1527);
  syz_mount_image(/*fs=*/0x20000600, /*dir=*/0x20000640,
                  /*flags=MS_POSIXACL|MS_STRICTATIME|MS_NOSUID*/ 0x1010002,
                  /*opts=*/0x20001200, /*chdir=*/1, /*size=*/0x5f7,
                  /*img=*/0x20000c80);
  memcpy((void*)0x20000180, "./file0/file0\000", 14);
  memcpy((void*)0x200001c0, "./file1\000", 8);
  syscall(__NR_rename, /*old=*/0x20000180ul, /*new=*/0x200001c0ul);
}
int main(void)
{
  syscall(__NR_mmap, /*addr=*/0x1ffff000ul, /*len=*/0x1000ul, /*prot=*/0ul,
          /*flags=MAP_FIXED|MAP_ANONYMOUS|MAP_PRIVATE*/ 0x32ul, /*fd=*/-1,
          /*offset=*/0ul);
  syscall(__NR_mmap, /*addr=*/0x20000000ul, /*len=*/0x1000000ul,
          /*prot=PROT_WRITE|PROT_READ|PROT_EXEC*/ 7ul,
          /*flags=MAP_FIXED|MAP_ANONYMOUS|MAP_PRIVATE*/ 0x32ul, /*fd=*/-1,
          /*offset=*/0ul);
  syscall(__NR_mmap, /*addr=*/0x21000000ul, /*len=*/0x1000ul, /*prot=*/0ul,
          /*flags=MAP_FIXED|MAP_ANONYMOUS|MAP_PRIVATE*/ 0x32ul, /*fd=*/-1,
          /*offset=*/0ul);
  loop();
  return 0;
}

